Уязвимость в подсистеме io_uring, приводящая к повышению привилегий

В реализации интерфейса асинхронного ввода/вывода io_uring, входящего в ядро Linux начиная с выпуска 5.1, выявлена уязвимость (CVE-2022-3910), позволяющая непривилегированному пользователю выполнить код с привилегиями ядра. Проблема проявляется в выпусках 5.18 и 5.19, и устранена в ветке 6.0. Debian, RHEL и SUSE используются выпуски ядра до 5.18, в Fedora, Gentoo и Arch уже предлагают ядро 6.0. В Ubuntu 22.10 задействовано уязвимое ядро 5.19.

Уязвимость вызвана обращением к уже освобождённому блоку памяти (use-after-free) в подсистеме io_uring, связанному с некорректным обновлением счётчика ссылок — при вызове io_msg_ring() с фиксированным файлом (постоянно находящемся в кольцевом буфере) осуществляется вызов функции io_fput_file(), по ошибке уменьшающий счётчик ссылок.

Источник: opennet.ru

Добавить комментарий